; 8/16MHz-Software-Umschalter
; 7.8.90 von Thomas Waldmann

                OUTPUT 'SWITCH16.PRG' ;nur fr TurboAss

_sysbase        EQU $04F2       ;wo ist das Betriebssystem ?
nvbls           EQU $0454       ;wieviele VBL-Eintrge ?
_vblqueue       EQU $0456       ;wo ist die VBL-Liste ?


start0:         bra.s   install         ;zur Installation

; es folgt der residente Teil:
vbl:            movea.l shiftp(PC),A0   ;VBL-Routine zur Tastenabfrage
                move.b  (A0),D0         ;Shift-Status holen
                and.b   mask(PC),D0     ;relevante Bits ausmaskieren
                cmp.b   trigger(PC),D0  ;richtige Tastenkomb. gedrckt ?
                bne.s   vbl_ret2        ;nein, dann nur Entprellflag lschen
                tst.b   sflag           ;Entprellflag gesetzt ?
                bne.s   vbl_ret         ;ja, dann nichts machen
                st      sflag           ;ansonsten setzen und ...
                bsr.s   switch          ;umschalten!
vbl_ret:        rts
vbl_ret2:       clr.b   sflag
                rts

;Folgendes fr Lsung mit GAL an Adresse sw_port
;sw_port         EQU $FFFF0001   ;das 1-Bit-Umschaltregister
;
;switch:         bchg    #0,sw_port      ; 8/16MHz umschalten
;                rts
;Ende Lsung mit GAL

;Folgendes fr Lsung mit PSG-PortA-Bit7
giselect        EQU $FFFF8800   ;PSG Select/Read Register
giwrite         EQU $FFFF8802   ;PSG Write Register
PORTA           EQU $0E         ;I/O-Port A des PSG
PORTBIT         EQU 7           ;Bit 7

switch:         move    SR,-(SP)
                move    #$2700,SR
                move.b  #PORTA,giselect.w
                move.b  giselect.w,D0
                bchg    #PORTBIT,D0
                move.b  D0,giwrite.w
                move    (SP)+,SR
                rts
;Ende Lsung mit PSG

shiftp:         DC.L $0E1B      ;Zeiger auf Shift-Status (fr TOS 1.0)

;Belegung der Bits in den trigger und mask:
;Bit Taste              Bit Taste
;0   Shift rechts       4   Capslock gesetzt
;1   Shift links        5   Maustaste rechts
;2   Control            6   Maustaste links
;3   Alternate          7   reserviert (0)

trigger:        DC.B %11        ;Shift-Status, der umschaltet (Shift-Shift)
mask:           DC.B %1111      ;Wert zum Maskieren des Shift-Status

sflag:          DC.B 0          ;zur Entprellung
                EVEN

;es folgt der (nicht residente) Installationsteil:

install:        lea     install(PC),A5  ;Lnge=Endadresse residenter Teil -
                suba.l  4(SP),A5        ;      Basepageadresse

                clr.w   -(SP)           ;Parameter fr Ptermres schon mal
                move.l  A5,-(SP)        ;auf den Stack legen

main:           pea     msg(PC)         ;Einschaltmeldung ausgeben
                move.w  #9,-(SP)
                trap    #1
                addq.l  #6,SP

                pea     sup_inst(PC)    ;eigentliche Installation durchfhren
                move.w  #$26,-(SP)
                trap    #14
                addq.l  #6,SP

                move.w  #$31,-(SP)      ;Ptermres
                trap    #1              ;Programmende, Prg aber resident halten


sup_inst:       movea.l _sysbase.w,A0   ;Adresse des Betriebssystems
                cmpi.w  #$0102,2(A0)    ;TOS-Version >= 1.2 ?
                bcs.s   cont            ;nein, dann also altes TOS
                move.l  $24(A0),shiftp  ;Zeiger auf Shift-Status holen

cont:           move.w  nvbls.w,D7      ; VBL-Routine installieren
                subq.w  #2,D7
                movea.l _vblqueue.w,A0
                addq.l  #4,A0           ;ersten Eintrag freilassen wg. GEM
i_loop:         tst.l   (A0)+
                dbeq    D7,i_loop
                bne.s   i_ret
                move.l  #vbl,-(A0)
i_ret:          rts

msg:            DC.B 13
                DC.B '8/16MHz-Switcher V1.0 installed',13,10
                DC.B 'Written 7.8.90 by Thomas Waldmann',13,10,0

                END
